/***************************************************************************
 *   Copyright (C) 2005 by Roberto Cappuccio                               *
 *   robertoc@dnet.it                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef DLGNEWCATALOG_H
#define DLGNEWCATALOG_H

#include <qvariant.h>
#include <kdialogbase.h>
#include <qstring.h>

#include "katcatalog.h"
#include "dlgmainwindow.h"

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QSpacerItem;
class QTabWidget;
class QWidget;
class QLineEdit;
class QLabel;
class QTextEdit;
class QPushButton;
class KActionSelector;
class QCheckBox;
class QSlider;
class DlgMainWindow;
class KURLRequester;

class DlgNewCatalog : public KDialogBase
{
    Q_OBJECT

public:
    DlgNewCatalog( DlgMainWindow* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~DlgNewCatalog();


public slots:
    virtual void changedCatalogname();
    virtual void slotOk();
    virtual void useExclusionList( int );
    virtual void manageExclusionList();
    virtual void thumbnailSizeSliderMoved( int );
    virtual void thumbnailSizeValueChanged( int );
    virtual void changedBaseFolder();

private:
    DlgMainWindow* mf;

    QTabWidget* tabWidget;
    KURLRequester* leBaseFolder;
    QLabel* tlCatalogName;
    QLabel* tlBaseFolder;
    QLabel* tlDescription;
    QLabel* tlAuthor;
    QLabel* tlNotes;
    QLineEdit* leAuthor;
    QTextEdit* teDescription;
    QTextEdit* teNotes;
    QLineEdit* leCatalogName;
    KActionSelector* asDescriptionPlugins;
    QWidget* TabPage;
    KActionSelector* asFullTextPlugins;
    QCheckBox* cbUseExclusionList;
    QPushButton* bManageExclusionList;
    KActionSelector* asThumbnailPlugins;
    QLabel* tlThumbnailSize;
    QSlider* slThumbnailSize;
    QLabel* tlSize;

};

#endif // DLGNEWCATALOG_H
