/***************************************************************************
 *   Copyright (C) 2005 by Roberto Cappuccio                               *
 *   robertoc@dnet.it                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef SEARCH_H
#define SEARCH_H

#include <qvariant.h>
#include <qpixmap.h>
#include <qwidget.h>
#include <kiconloader.h>

#include "kat.h"
#include "katdatabasemanager.h"

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QSpacerItem;
class QSplitter;
class QTabWidget;
class QLabel;
class QButtonGroup;
class QCheckBox;
class KPushButton;
class KLineEdit;
class KIconButton;
class KTextEdit;

class DlgSearch : public QWidget
{
    Q_OBJECT

public:
    DlgSearch( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~DlgSearch();

public slots:
    void simpleStartSearch();
     void simpleLimitSearch();
     void simpleConfigure();
     void advancedStartSearch();
     void criteriaAnd();
     void criteriaOr();
     void criteriaXor();
     void criteriaNot();
     void criteriaParenthesisOpen();
     void criteriaParenthesisClose();
     void criteriaInsert();
     void criteriaModify();
     void criteriaValidate();
     void advancedLimitSearch();
     void advancedConfigure();
     void advancedClose();
     void criteriaOptions();
     void simpleClose();

protected slots:
    virtual void languageChange();
    void slotTextChanged(const QString & );
private:
    QPixmap image0;
    QSplitter* splitter15;
    QSplitter* splitter14;
    QTabWidget* SearchSetup;
    QWidget* tab;
    QLabel* tlSearch;
    QButtonGroup* bgSearchParameters;
    QCheckBox* cbFilenames;
    QCheckBox* cbDescriptions;
    QCheckBox* cbFullTexts;
    KPushButton* pbLimitSimpleSearch;
    KPushButton* pbConfigureSimple;
    KLineEdit* leSearchText;
    KPushButton* ibStartSimpleSearch;
    KPushButton* pbCloseSimple;
    QWidget* tab_2;
    KPushButton* pbLimitAdvancedSearch;
    KPushButton* pbCloseAdvanced;
    KPushButton* pbOptions;
    KPushButton* pbValidate;
    KPushButton* pbModify;
    KPushButton* pbAnd;
    KPushButton* pbOr;
    KPushButton* pbXor;
    KPushButton* pbNot;
    KPushButton* pbParenthesisOpen;
    KPushButton* pbParenthesisClose;
    KTextEdit* teCriteria;
    KPushButton* pbConfigureAdvanced;
    KPushButton* ibStartAdvancedSearch;
    KPushButton* pbInsert;

};

#endif // SEARCH_H
