/***************************************************************************
 *   Copyright (C) 2005 by Roberto Cappuccio                               *
 *   robertoc@dnet.it                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef KATCATALOG_H
#define KATCATALOG_H

#include <qstring.h>
#include <iostream>
#include <stdio.h>
#include <time.h>
#include <sys/stat.h>
#include <qwidget.h>
#include <qapplication.h>
#include <kdebug.h>
#include <kio/job.h>

using namespace std;

class KatDatabaseManager;

class KatCatalog : public QObject {
Q_OBJECT

private:
    QString name;
    QString description;
    QString filename;
    QString path;
    QString notes;
    QString author;
    time_t creationDate;
    time_t lastUpdateDate;
    int useExclusionList;
    int thumbnailSize;
    long files;
    long folders;
    long words;
    long fullTexts;
    long thumbnails;
    long metaData;
    KIO::filesize_t extractions;
    KIO::filesize_t fileSize;

public:
    KatCatalog();
    virtual ~KatCatalog();

    // Getters
    QString getName() const;
    QString getDescription() const;
    QString getFilename() const;
    QString getPath() const;
    QString getNotes() const;
    QString getAuthor() const;
    time_t getCreationDate() const;
    time_t getLastUpdateDate() const;
    int getUseExclusionList() const;
    int getThumbnailSize()const ;
    long getFiles() const;
    long getFolders() const;
    long getWords() const ;
    long getFullTexts() const;
    long getThumbnails() const;
    long getMetaData() const;
    long getExtractions() const;
    KIO::filesize_t getFileSize() const;

    // Setters
    void setName( const QString& );
    void setDescription( const QString& );
    void setFilename( const QString& );
    void setPath( const QString& );
    void setNotes( const QString& );
    void setAuthor( const QString& );
    void setCreationDate( time_t );
    void setLastUpdateDate( time_t );
    void setUseExclusionList( int );
    void setThumbnailSize( int );
    void setFiles( long );
    void setFolders( long );
    void setWords( long );
    void setFullTexts( long );
    void setThumbnails( long );
    void setMetaData( long );
    void setExtractions( long );
    void setFileSize( KIO::filesize_t );

    int save( QString, const QString& );
    int open( const QString& );
    int query( const QString& );
    int saveCatalogInfo(KatDatabaseManager *_dm);
};

#endif // KATCATALOG_H
